# $Revision: 1.85 $, $Date: 2012/01/13 21:00:46 $
#
# TODO
# 	- maybe separate other prolog packages to rpm subpackages
#
# Conditional build:
%bcond_without	java		# don't build with java bindings (So far, JPL only works with Sun Java and IBM Java)
#

%ifnarch %{x8664} i586 i686 pentium3 pentium4 athlon 
%undefine	with_java
%endif

%define		xpce_version 6.6.66
Summary:	SWI Prolog Language
Summary(pl.UTF-8):	Język SWI Prolog
Name:		pl
Version:	5.10.4
Release:	3
License:	LGPL/GPL
Group:		Development/Languages
Source0:	http://www.swi-prolog.org/download/stable/src/%{name}-%{version}.tar.gz
# Source0-md5:	363433bb2f80a6c2befeaee7768197b4
Patch0:		%{name}-clib-configure.patch
URL:		http://www.swi-prolog.org/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	db-devel
BuildRequires:	fontconfig-devel
BuildRequires:	freetype-devel
BuildRequires:	gmp-devel
%{?with_java:BuildRequires:	jdk}
BuildRequires:	libjpeg-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:	pkgconfig
BuildRequires:	readline-devel >= 4.2
BuildRequires:	unixODBC-devel
BuildRequires:	uriparser-devel
BuildRequires:	xorg-lib-libICE-devel
BuildRequires:	xorg-lib-libSM-devel
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXaw-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXft-devel
BuildRequires:	xorg-lib-libXinerama-devel
BuildRequires:	xorg-lib-libXmu-devel
BuildRequires:	xorg-lib-libXpm-devel
BuildRequires:	xorg-lib-libXrender-devel
BuildRequires:	xorg-lib-libXt-devel
BuildRequires:	zlib-devel
Obsoletes:	swi-pl
Obsoletes:	swi-prolog
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		no_install_post_chrpath		1

%description
ISO/Edinburgh-style Prolog compiler including modules, autoload,
libraries, Garbage-collector, stack-expandor, C/C++-interface,
GNU-readline interface, very fast compiler. Including packages clib
(Unix process control and sockets), cpp (C++ interface), sgml (reading
XML/SGML), sgml/RDF (reading RDF into triples) and XPCE (Graphics UI
toolkit, integrated editor (Emacs-clone) and source-level debugger).

%description -l pl.UTF-8
Kompilator języka PROLOG w stylu Edinburgh wraz z modułami,
bibliotekami, garbage collectorrem, interfejsem C, interfejsami do GNU
readline, GNU Emacsa i X11 przy użyciu XPCE.

%package jpl
Summary:	Dynamic, bidirectional interface between SWI-Prolog and Java
Summary(pl.UTF-8):	Dynamiczny, dwukierunkowy interfejs pomiędzy SWI-Prologiem a Javą
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Requires:	java-sun

%description jpl
JPL 3.x is a dynamic, bidirectional interface between SWI-Prolog 5.2.0 or
later and Java 2 runtimes (see JPL 3.x Objectives). It offers two APIs:
  * Java API (Java-calls-Prolog): this interface comprises public Java
    classes which support:
       + constructing Java representations of Prolog terms and queries
       + calling queries within SWI-Prolog engines
       + retrieving (as Java representations of Prolog terms) any bindings
         created by a call
  * Prolog API (Prolog-calls-Java): this interface comprises Prolog library
    predicates which support:
       + creating instances (objects) of Java classes (built-in and
         user-defined)
       + calling methods of Java objects (and static methods of classes),
         perhaps returning values or object references
       + getting and setting the values of fields of Java objects and
         classes

Calls to the two APIs can be nested, e.g. Java code can call Prolog
predicates which call Java methods which call Prolog predicates etc.

%description jpl -l pl.UTF-8
JPL 3.x to dynamiczny, dwukierunkowy interfejs pomiędzy SWI-Prologiem
5.2.0 i późniejszymi a środowiskami uruchomieniowymi Javy 2 (więcej w
dokumencie JPL 3.x Objectives). Oferuje dwa API:
  - API Javy (wywołania Prologu z Javy) - ten interfejs obejmuje klasy
    publiczne Javy obsługujące:
    - tworzenie reprezentacji wyrażeń i zapytań Prologu w Javie
    - wywoływanie zapytań wewnątrz silników SWI-Prologu
    - odtwarzanie (jako reprezentacji wyrażeń Prologu w Javie)
      wszelkich dowiązań utworzonych przez wywołanie
  - API Prologu (wywołania Javy z Prologu) - ten interfejs obejmuje
    predykaty biblioteki Prologu obsługującą:
    - tworzenie instancji (obiektów) klas Javy (wbudowanych i
      zdefiniowanych przez użytkownika)
    - wywołania metod obiektów (i statycznych metod klas) Javy, także
      zwracających wartości lub referencje do obiektów
    - pobieranie i ustawianie wartości pól obiektów i klas Javy

Wywołania obu API mogą być zagnieżdżane, np. kod w Javie może wywołać
predykaty Prologu wywołujące metody Javy, które wywołują predykaty
Prologu itd.

%package xpce
Summary:	XPCE - GUI Toolkit for (SWI-)Prolog
Summary(pl.UTF-8):	XPCE - toolkit graficzny dla (SWI-)Prologu
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Obsoletes:	xpce

%description xpce
Graphical User Interface (GUI) toolkit for Prolog and other
dynamically typed languages. Provides Object Oriented programming to
Prolog as well as a high-level portable GUI toolkit for (SWI-)Prolog.
Also available for Quintus and SICStus Prolog.

%description xpce -l pl.UTF-8
Zestaw Graficzny Interfejsu Użytkownika (GUI) dla Prologu i innych
dynamicznie wpisywanych języków. Udostępnia obiektowo zorientowane
programowanie dla Prologu jak także jako wysoko dostępny przenośny
zestaw GUI dla (SWI-)Prologu. Dostępne także dla Quintus i SICStus
Prolog.

%prep
%setup -q
%patch0 -p1

%build
cd src
cp -f /usr/share/automake/config.sub .
%{__aclocal}
%{__autoconf}
%configure
%{__make}
%{__make} check
cd ..

# the packages are written in Prolog itself
PATH="$(pwd)/src:$PATH"; export PATH
LD_LIBRARY_PATH="$(pwd)/lib/%{_target_cpu}-linux"; export LD_LIBRARY_PATH

cd packages
wd=`pwd`
for i in clib cpp odbc table xpce/src sgml RDF semweb http chr \
		clpqr nlp ssl tipc pldoc plunit %{?with_java:jpl} \
		zlib R protobufs \
		inclpr ; do
	cd $i
	cp -f /usr/share/automake/config.sub .
	%{__aclocal}
	%{__autoconf}
	%{__autoheader} || :
	%configure
	%{__make}
	cd $wd
done
cd ..

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -j1 install -C src \
	DESTDIR=$RPM_BUILD_ROOT

LD_LIBRARY_PATH="$RPM_BUILD_ROOT%{_libdir}/swipl-%{version}/lib/%{_target_cpu}-linux"; export LD_LIBRARY_PATH

for i in clib cpp odbc table xpce/src sgml RDF semweb http chr \
		clpqr nlp ssl tipc pldoc plunit %{?with_java:jpl} \
		zlib R protobufs \
		inclpr ; do
	PATH=$RPM_BUILD_ROOT%{_bindir}:$PATH \
	%{__make} -j1 install -C packages/$i \
		PLBASE=$RPM_BUILD_ROOT%{_libdir}/swipl-%{version} \
		prefix=$RPM_BUILD_ROOT%{_prefix} \
		bindir=$RPM_BUILD_ROOT%{_bindir} \
		mandir=$RPM_BUILD_ROOT%{_mandir}/man1
done

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc README* ReleaseNotes/*
%doc dotfiles/dot*
%attr(755,root,root) %{_bindir}/swipl*
%dir %{_libdir}/swipl-%{version}
%attr(755,root,root) %{_libdir}/swipl-%{version}/bin
%{_libdir}/swipl-%{version}/boot*
%dir %{_libdir}/swipl-%{version}/lib
%dir %{_libdir}/swipl-%{version}/lib/*-linux
%attr(755,root,root) %{_libdir}/swipl-%{version}/lib/*-linux/*.so*
%{_libdir}/swipl-%{version}/lib/*-linux/*.a
%{_libdir}/swipl-%{version}/library
%if %{with java}
%exclude %{_libdir}/swipl-%{version}/lib/*-linux/libjpl.so
%exclude %{_libdir}/swipl-%{version}/library/jpl.pl
%endif
%{_libdir}/swipl-%{version}/include
%{_libdir}/swipl-%{version}/do*
%{_libdir}/swipl-%{version}/*.rc
%{_libdir}/swipl-%{version}/swipl.home
%{_pkgconfigdir}/swipl.pc
%{_mandir}/man?/swipl*

%files xpce
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/xpce*
%dir %{_libdir}/swipl-%{version}/xpce-%{xpce_version}
%{_libdir}/swipl-%{version}/xpce
%attr(755,root,root) %{_libdir}/swipl-%{version}/xpce-%{xpce_version}/bin
%attr(755,root,root) %{_libdir}/swipl-%{version}/xpce-%{xpce_version}/lib
%{_libdir}/swipl-%{version}/xpce-%{xpce_version}/appl-help
%{_libdir}/swipl-%{version}/xpce-%{xpce_version}/bitmaps
%{_libdir}/swipl-%{version}/xpce-%{xpce_version}/man
%{_libdir}/swipl-%{version}/xpce-%{xpce_version}/pl
%{_libdir}/swipl-%{version}/xpce-%{xpce_version}/prolog

%if %{with java}
%files jpl
%defattr(644,root,root,755)
%{_libdir}/swipl-%{version}/lib/jpl.jar
%attr(755,root,root) %{_libdir}/swipl-%{version}/lib/*-linux/libjpl.so
%{_libdir}/swipl-%{version}/library/jpl.pl
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: pl.spec,v $
Revision 1.85  2012/01/13 21:00:46  arekm
- release 3

Revision 1.84  2011/09/01 13:05:23  baggins
- rel 2
- don't remove rpath pl has libs in strange place

Revision 1.83  2011/04/12 12:41:48  baggins
- 5.10.4

Revision 1.82  2010/04/15 15:48:32  baggins
- xpce version 6.6.66 ;)

Revision 1.81  2010/04/15 15:38:37  baggins
- up to 5.8.3 stable

Revision 1.80  2009/04/11 07:59:06  qboosh
- remaining pl

Revision 1.79  2009/03/11 11:34:55  baggins
- rel 1
- jpl requires java-sun

Revision 1.78  2009/03/11 11:14:31  baggins
- more bcond fun

Revision 1.77  2009/03/11 11:08:49  baggins
- fix java bcond usage

Revision 1.76  2009/03/11 11:06:02  baggins
- clarify License
- added jpl package
- rename xpce to pl-xpce

Revision 1.75  2009/03/11 10:49:51  baggins
- kill patch added by mistake

Revision 1.74  2009/03/11 10:46:23  baggins
- BR java-sun
- added java bcond
- don't build java bindings on archs not supported by java-sun

Revision 1.73  2009/03/10 18:16:54  baggins
- 5.7.7
- go with development branch, at least it's 64 bit safe

Revision 1.72  2009/03/05 23:18:44  baggins
- rel 4
- parallel install isn't deterministic

Revision 1.71  2009/03/05 23:05:14  baggins
- rel 3
- added missing dir

Revision 1.70  2009/03/05 22:35:22  baggins
- rel 2

Revision 1.69  2009/02/16 14:30:35  baggins
- attempt at modular xorg BRs
- updated install and files

Revision 1.68  2009/02/16 11:33:35  baggins
- 5.6.64

Revision 1.67  2008/02/21 13:10:47  undefine
- up to 5.6.50

Revision 1.66  2007/02/13 08:06:41  glen
- tabs in preamble

Revision 1.65  2007/02/12 01:06:22  baggins
- converted to UTF-8

Revision 1.64  2005/09/17 11:55:06  arekm
- new readline, 5.0

Revision 1.63  2004/05/20 19:47:47  qboosh
- perform tests on alpha too (passed now); release 2

Revision 1.62  2004/05/20 19:17:44  qboosh
- added opt patch to use our optflags (fixes tests on ppc by -fsigned-char)

Revision 1.61  2004/05/19 17:45:27  undefine
- fix build, simplify

Revision 1.60  2004/03/01 12:42:32  baggins
- xpce is 6.2.13

Revision 1.59  2004/03/01 12:41:39  baggins
- updated to 5.2.13
- moved MANUAL back to libs ('help' predicate didn't work),
	DON'T FUCK WITH IT if you don't know what you're doing!

Revision 1.58  2004/01/18 13:35:53  undefine
- release 2, amd64 fixes...

Revision 1.57  2004/01/17 01:15:32  saq
- fixed xpce_version and its files
- use the newly-compiled Prolog compiler to compile the packages
  (no bootstrap needed)

Revision 1.56  2003/11/15 23:45:59  undefine
- update to 5.2.10

Revision 1.55  2003/10/30 23:33:46  ankry
- objekt -> obiekt

Revision 1.54  2003/10/13 16:39:17  undefine
- update to 5.2.8, stb

Revision 1.53  2003/10/03 15:00:48  qboosh
- cosmetics

Revision 1.52  2003/08/29 18:03:03  blues
- release 2

Revision 1.51  2003/08/26 23:19:17  gotar
- no // in paths, sort, white space cleaning

Revision 1.50  2003/08/22 08:28:52  qboosh
- cosmetics

Revision 1.49  2003/08/22 06:08:40  ankry
- adapterized

Revision 1.48  2003/08/22 01:39:37  undefine
- don't make checks on alpha... mayby it help? ;)

Revision 1.47  2003/08/22 01:37:57  undefine
- man from xpce to xpce subpackage. call sleep()

Revision 1.46  2003/08/22 01:32:16  undefine
- xpce separated, not testet yet. I need sleeeep!!!

Revision 1.45  2003/08/21 23:58:27  undefine
- real build extras subpackages.
- xpce package doesn't finished(need substraction to subpackage)
- release 1.1

Revision 1.44  2003/08/21 22:54:22  undefine
- update to 5.2.6, stb

Revision 1.43  2003/08/21 15:21:20  qboosh
- no // in paths, other cosmetics

Revision 1.42  2003/08/18 08:09:29  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.41  2003/06/16 19:46:20  blues
- changes inpired by kloczek: URL upper-case
- small other changes and cleanups

Revision 1.40  2003/06/13 18:32:50  mwinkler
- small url fix

Revision 1.39  2003/05/28 13:01:18  malekith
- massive attack: source-md5

Revision 1.38  2003/05/25 06:25:32  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.37  2002/11/01 02:05:57  undefine
- change some perms
- release 4
- stbr

Revision 1.36  2002/10/14 12:32:23  undefine
- change manpage from readline.3 to readline.3pl to avoid conflicts with readline-devel
- stbr

Revision 1.35  2002/10/09 13:14:45  kloczek
- use more macros, some cosmetics, added missing "rm -f missing" and use new %doc

Revision 1.34  2002/09/11 11:05:38  undefine
- release 3(to allow upgrade from mandrake)
- make check
- some cleanup

Revision 1.33  2002/09/07 11:57:08  undefine
- starting upgrade to 5.0.8
- nfy

Revision 1.32  2002/05/21 23:14:31  kloczek
perl -pi -e "s/^automake -a -c -f --foreing/\%\{__automake\}/; \
             s/^automake -a -c -f/\%\{__automake\}/; \
	     s/^autoconf/\%\{__autoconf\}/"

Revision 1.31  2002/02/23 04:17:27  kloczek
- adapterized.

Revision 1.30  2002/02/22 23:29:36  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.29  2002/01/18 02:14:37  kloczek
perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.28  2001/12/23 09:07:31  filon
- moved manual for libdir to docs :-)
- release 4

Revision 1.27  2001/10/03 07:55:13  qboosh
- BuildRequires: autoconf, automake
- longer pl description
- fixed %%configure in changelog (so it won't be expanded in RPM)

Revision 1.26  2001/10/02 13:26:07  cieciwa
- s/%%configure/%%configure2_13/

Revision 1.25  2001/09/21 22:56:06  blues
- release 3
- ac2.5 ready

Revision 1.24  2001/04/13 18:21:43  wiget
build with readline 4.2

Revision 1.23  2000/11/12 04:47:21  kloczek
- updated to 3.4.2,
- added BuildRequires rules.

Revision 1.22  2000/10/20 17:06:38  kloczek
- adapterized.

Revision 1.21  2000/10/20 15:31:36  baggins
- fixed %%doc list

Revision 1.20  2000/10/20 15:27:29  baggins
- added DESTDIR patch
- license is now GPL

Revision 1.19  2000/10/10 19:10:15  baggins
- fixed source URL

Revision 1.18  2000/10/10 19:09:47  baggins
- updated to 3.4.0

Revision 1.17  2000/06/09 07:55:08  kloczek
- more %%{__make} macros.

Revision 1.16  2000/06/09 07:23:46  kloczek
- added using %%{__make} macro.

Revision 1.15  2000/06/07 04:31:54  kloczek
- spec adapterized.

Revision 1.14  2000/04/01 11:15:35  zagrodzki
- changed all BuildRoot definitons
- removed all applnkdir defs
- changed some prereqs/requires
- removed duplicate empty lines

Revision 1.13  2000/03/28 16:55:03  baggins
- translated kloczkish into english

Revision 1.12  1999/11/28 16:20:37  wiget
- updated to 3.3.0
- fixed source url
Warning: I can't compile this

Revision 1.11  1999/11/23 15:43:36  baggins
- fixed arch problems
- cleaned up %files

Revision 1.10  1999/07/12 23:06:12  kloczek
- added using CVS keywords in %changelog (for automating them).
